// Package common provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package common

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	externalRef0 "oransc.org/nonrtric/capifcore/internal/common29571"
)

// Defines values for AfResultStatus.
const (
	AfResultStatusOTHER AfResultStatus = "OTHER"

	AfResultStatusRELOCNOALLOWED AfResultStatus = "RELOC_NO_ALLOWED"

	AfResultStatusSUCCESS AfResultStatus = "SUCCESS"

	AfResultStatusTEMPORARYCONGESTION AfResultStatus = "TEMPORARY_CONGESTION"
)

// Defines values for FlowDirection.
const (
	FlowDirectionBIDIRECTIONAL FlowDirection = "BIDIRECTIONAL"

	FlowDirectionDOWNLINK FlowDirection = "DOWNLINK"

	FlowDirectionUNSPECIFIED FlowDirection = "UNSPECIFIED"

	FlowDirectionUPLINK FlowDirection = "UPLINK"
)

// Defines values for NotificationMethod.
const (
	NotificationMethodONETIME NotificationMethod = "ONE_TIME"

	NotificationMethodONEVENTDETECTION NotificationMethod = "ON_EVENT_DETECTION"

	NotificationMethodPERIODIC NotificationMethod = "PERIODIC"
)

// Defines values for SupportedGADShapes.
const (
	SupportedGADShapesELLIPSOIDARC SupportedGADShapes = "ELLIPSOID_ARC"

	SupportedGADShapesLOCAL2DPOINTUNCERTAINTYELLIPSE SupportedGADShapes = "LOCAL_2D_POINT_UNCERTAINTY_ELLIPSE"

	SupportedGADShapesLOCAL3DPOINTUNCERTAINTYELLIPSOID SupportedGADShapes = "LOCAL_3D_POINT_UNCERTAINTY_ELLIPSOID"

	SupportedGADShapesPOINT SupportedGADShapes = "POINT"

	SupportedGADShapesPOINTALTITUDE SupportedGADShapes = "POINT_ALTITUDE"

	SupportedGADShapesPOINTALTITUDEUNCERTAINTY SupportedGADShapes = "POINT_ALTITUDE_UNCERTAINTY"

	SupportedGADShapesPOINTUNCERTAINTYCIRCLE SupportedGADShapes = "POINT_UNCERTAINTY_CIRCLE"

	SupportedGADShapesPOINTUNCERTAINTYELLIPSE SupportedGADShapes = "POINT_UNCERTAINTY_ELLIPSE"

	SupportedGADShapesPOLYGON SupportedGADShapes = "POLYGON"
)

// IP address and/or FQDN.
type AddrFqdn struct {
	// Indicates an FQDN.
	Fqdn *string `json:"fqdn,omitempty"`

	// Contains an IP adresse.
	IpAddr *externalRef0.IpAddr `json:"ipAddr,omitempty"`
}

// Identifies the result of application layer handling.
type AfResultInfo struct {
	// Possible values are:
	// - SUCCESS: The application layer is ready or the relocation is completed.
	// - TEMPORARY_CONGESTION: The application relocation fails due to temporary congestion.
	// - RELOC_NO_ALLOWED: The application relocation fails because application relocation is not allowed.
	// - OTHER: The application relocation fails due to other reason.
	AfStatus AfResultStatus `json:"afStatus"`

	// Contains EAS IP replacement information.
	EasIpReplaceInfos *[]externalRef0.EasIpReplacementInfo `json:"easIpReplaceInfos,omitempty"`

	// At least one of the "routeInfo" attribute and the "routeProfId" attribute shall be included in the "RouteToLocation" data type.
	TrafficRoute *externalRef0.RouteToLocation `json:"trafficRoute"`

	// If present and set to "true" it indicates that buffering of uplink traffic to the target DNAI is needed.
	UpBuffInd *bool `json:"upBuffInd,omitempty"`
}

// Possible values are:
// - SUCCESS: The application layer is ready or the relocation is completed.
// - TEMPORARY_CONGESTION: The application relocation fails due to temporary congestion.
// - RELOC_NO_ALLOWED: The application relocation fails because application relocation is not allowed.
// - OTHER: The application relocation fails due to other reason.
type AfResultStatus string

// Indicates value of altitude.
type Altitude float64

// Indicates value of angle.
type Angle int

// Indicates a Civic address.
type CivicAddress struct {
	A1         *string `json:"A1,omitempty"`
	A2         *string `json:"A2,omitempty"`
	A3         *string `json:"A3,omitempty"`
	A4         *string `json:"A4,omitempty"`
	A5         *string `json:"A5,omitempty"`
	A6         *string `json:"A6,omitempty"`
	ADDCODE    *string `json:"ADDCODE,omitempty"`
	BLD        *string `json:"BLD,omitempty"`
	FLR        *string `json:"FLR,omitempty"`
	HNO        *string `json:"HNO,omitempty"`
	HNS        *string `json:"HNS,omitempty"`
	LMK        *string `json:"LMK,omitempty"`
	LOC        *string `json:"LOC,omitempty"`
	NAM        *string `json:"NAM,omitempty"`
	PC         *string `json:"PC,omitempty"`
	PCN        *string `json:"PCN,omitempty"`
	PLC        *string `json:"PLC,omitempty"`
	POBOX      *string `json:"POBOX,omitempty"`
	POD        *string `json:"POD,omitempty"`
	POM        *string `json:"POM,omitempty"`
	PRD        *string `json:"PRD,omitempty"`
	PRM        *string `json:"PRM,omitempty"`
	RD         *string `json:"RD,omitempty"`
	RDBR       *string `json:"RDBR,omitempty"`
	RDSEC      *string `json:"RDSEC,omitempty"`
	RDSUBBR    *string `json:"RDSUBBR,omitempty"`
	ROOM       *string `json:"ROOM,omitempty"`
	SEAT       *string `json:"SEAT,omitempty"`
	STS        *string `json:"STS,omitempty"`
	UNIT       *string `json:"UNIT,omitempty"`
	Country    *string `json:"country,omitempty"`
	Method     *string `json:"method,omitempty"`
	ProvidedBy *string `json:"providedBy,omitempty"`
	UsageRules *string `json:"usageRules,omitempty"`
}

// Describes a communication failure detected by AMF
type CommunicationFailure struct {
	NasReleaseCode *string `json:"nasReleaseCode,omitempty"`

	// Represents the NGAP cause.
	RanReleaseCode *externalRef0.NgApCause `json:"ranReleaseCode,omitempty"`
}

// Indicates value of confidence.
type Confidence int

// Represents the content version of some content.
type ContentVersion int

// EllipsoidArc defines model for EllipsoidArc.
type EllipsoidArc struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of confidence.
	Confidence Confidence `json:"confidence"`

	// Indicates value of angle.
	IncludedAngle Angle `json:"includedAngle"`

	// Indicates value of the inner radius.
	InnerRadius InnerRadius `json:"innerRadius"`

	// Indicates value of angle.
	OffsetAngle Angle `json:"offsetAngle"`

	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`

	// Indicates value of uncertainty.
	UncertaintyRadius Uncertainty `json:"uncertaintyRadius"`
}

// Identifies an Ethernet flow.
type EthFlowDescription struct {
	// String identifying a MAC address formatted in the hexadecimal notation according to clause 1.1 and clause 2.1 of RFC 7042.
	DestMacAddr *externalRef0.MacAddr48 `json:"destMacAddr,omitempty"`

	// String identifying a MAC address formatted in the hexadecimal notation according to clause 1.1 and clause 2.1 of RFC 7042.
	DestMacAddrEnd *externalRef0.MacAddr48 `json:"destMacAddrEnd,omitempty"`
	EthType        string                  `json:"ethType"`

	// Defines a packet filter of an IP flow.
	FDesc *FlowDescription `json:"fDesc,omitempty"`

	// Possible values are
	// - DOWNLINK: The corresponding filter applies for traffic to the UE.
	// - UPLINK: The corresponding filter applies for traffic from the UE.
	// - BIDIRECTIONAL: The corresponding filter applies for traffic both to and from the UE.
	// - UNSPECIFIED: The corresponding filter applies for traffic to the UE (downlink), but has no specific direction declared. The service data flow detection shall apply the filter for uplink traffic as if the filter was bidirectional. The PCF shall not use the value UNSPECIFIED in filters created by the network in NW-initiated procedures. The PCF shall only include the value UNSPECIFIED in filters in UE-initiated procedures if the same value is received from the SMF.
	FDir *FlowDirection `json:"fDir,omitempty"`

	// String identifying a MAC address formatted in the hexadecimal notation according to clause 1.1 and clause 2.1 of RFC 7042.
	SourceMacAddr *externalRef0.MacAddr48 `json:"sourceMacAddr,omitempty"`

	// String identifying a MAC address formatted in the hexadecimal notation according to clause 1.1 and clause 2.1 of RFC 7042.
	SrcMacAddrEnd *externalRef0.MacAddr48 `json:"srcMacAddrEnd,omitempty"`
	VlanTags      *[]string               `json:"vlanTags,omitempty"`
}

// Defines a packet filter of an IP flow.
type FlowDescription string

// Possible values are
// - DOWNLINK: The corresponding filter applies for traffic to the UE.
// - UPLINK: The corresponding filter applies for traffic from the UE.
// - BIDIRECTIONAL: The corresponding filter applies for traffic both to and from the UE.
// - UNSPECIFIED: The corresponding filter applies for traffic to the UE (downlink), but has no specific direction declared. The service data flow detection shall apply the filter for uplink traffic as if the filter was bidirectional. The PCF shall not use the value UNSPECIFIED in filters created by the network in NW-initiated procedures. The PCF shall only include the value UNSPECIFIED in filters in UE-initiated procedures if the same value is received from the SMF.
type FlowDirection string

// Common base type for GAD shapes.
type GADShape struct {
	// Indicates supported GAD shapes.
	Shape SupportedGADShapes `json:"shape"`
}

// Geographic area specified by different shape.
type GeographicArea interface{}

// Geographical coordinates.
type GeographicalCoordinates struct {
	Lat float64 `json:"lat"`
	Lon float64 `json:"lon"`
}

// Indicates value of the inner radius.
type InnerRadius int32

// Range of IPv4 addresses
type Ipv4AddressRange struct {
	// String identifying a IPv4 address formatted in the 'dotted decimal' notation as defined in RFC 1166.
	End *externalRef0.Ipv4Addr `json:"end,omitempty"`

	// String identifying a IPv4 address formatted in the 'dotted decimal' notation as defined in RFC 1166.
	Start *externalRef0.Ipv4Addr `json:"start,omitempty"`
}

// Local2dPointUncertaintyEllipse defines model for Local2dPointUncertaintyEllipse.
type Local2dPointUncertaintyEllipse struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of confidence.
	Confidence Confidence `json:"confidence"`

	// Indicates a Local origin in a reference system
	LocalOrigin LocalOrigin `json:"localOrigin"`

	// Relative Cartesian Location
	Point RelativeCartesianLocation `json:"point"`

	// Ellipse with uncertainty.
	UncertaintyEllipse UncertaintyEllipse `json:"uncertaintyEllipse"`
}

// Local3dPointUncertaintyEllipsoid defines model for Local3dPointUncertaintyEllipsoid.
type Local3dPointUncertaintyEllipsoid struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of confidence.
	Confidence Confidence `json:"confidence"`

	// Indicates a Local origin in a reference system
	LocalOrigin LocalOrigin `json:"localOrigin"`

	// Relative Cartesian Location
	Point RelativeCartesianLocation `json:"point"`

	// Ellipsoid with uncertainty
	UncertaintyEllipsoid UncertaintyEllipsoid `json:"uncertaintyEllipsoid"`
}

// Indicates a Local origin in a reference system
type LocalOrigin struct {
	CoordinateId *string `json:"coordinateId,omitempty"`

	// Geographical coordinates.
	Point *GeographicalCoordinates `json:"point,omitempty"`
}

// Describes a network area information in which the NF service consumer requests the number of UEs.
type NetworkAreaInfo struct {
	// Contains a list of E-UTRA cell identities.
	Ecgis *[]externalRef0.Ecgi `json:"ecgis,omitempty"`

	// Contains a list of NG RAN nodes.
	GRanNodeIds *[]externalRef0.GlobalRanNodeId `json:"gRanNodeIds,omitempty"`

	// Contains a list of NR cell identities.
	Ncgis *[]externalRef0.Ncgi `json:"ncgis,omitempty"`

	// Contains a list of tracking area identities.
	Tais *[]externalRef0.Tai `json:"tais,omitempty"`
}

// Possible values are:
// - PERIODIC
// - ONE_TIME
// - ON_EVENT_DETECTION
type NotificationMethod string

// Indicates value of orientation angle.
type Orientation int

// Point defines model for Point.
type Point struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`
}

// PointAltitude defines model for PointAltitude.
type PointAltitude struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of altitude.
	Altitude Altitude `json:"altitude"`

	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`
}

// PointAltitudeUncertainty defines model for PointAltitudeUncertainty.
type PointAltitudeUncertainty struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of altitude.
	Altitude Altitude `json:"altitude"`

	// Indicates value of confidence.
	Confidence Confidence `json:"confidence"`

	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`

	// Indicates value of uncertainty.
	UncertaintyAltitude Uncertainty `json:"uncertaintyAltitude"`

	// Ellipse with uncertainty.
	UncertaintyEllipse UncertaintyEllipse `json:"uncertaintyEllipse"`
}

// List of points.
type PointList []GeographicalCoordinates

// PointUncertaintyCircle defines model for PointUncertaintyCircle.
type PointUncertaintyCircle struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`

	// Indicates value of uncertainty.
	Uncertainty Uncertainty `json:"uncertainty"`
}

// PointUncertaintyEllipse defines model for PointUncertaintyEllipse.
type PointUncertaintyEllipse struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// Indicates value of confidence.
	Confidence Confidence `json:"confidence"`

	// Geographical coordinates.
	Point GeographicalCoordinates `json:"point"`

	// Ellipse with uncertainty.
	UncertaintyEllipse UncertaintyEllipse `json:"uncertaintyEllipse"`
}

// Polygon defines model for Polygon.
type Polygon struct {
	// Embedded struct due to allOf(#/components/schemas/GADShape)
	GADShape `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// List of points.
	PointList PointList `json:"pointList"`
}

// Relative Cartesian Location
type RelativeCartesianLocation struct {
	// string with format 'float' as defined in OpenAPI.
	X externalRef0.Float `json:"x"`

	// string with format 'float' as defined in OpenAPI.
	Z *externalRef0.Float `json:"z,omitempty"`
}

// Represents the type of reporting that the subscription requires.
type ReportingInformation struct {
	// indicating a time in seconds.
	GrpRepTime *externalRef0.DurationSec `json:"grpRepTime,omitempty"`
	ImmRep     *bool                     `json:"immRep,omitempty"`

	// Unsigned Integer, i.e. only value 0 and integers above 0 are permissible.
	MaxReportNbr *externalRef0.Uinteger `json:"maxReportNbr,omitempty"`

	// string with format 'date-time' as defined in OpenAPI.
	MonDur *externalRef0.DateTime `json:"monDur,omitempty"`

	// Possible values are:
	// - ACTIVATE: The event notification is activated.
	// - DEACTIVATE: The event notification is deactivated and shall be muted. The available
	//    event(s) shall be stored.
	// - RETRIEVAL: The event notification shall be sent to the NF service consumer(s),
	//   after that, is muted again.
	NotifFlag *externalRef0.NotificationFlag `json:"notifFlag,omitempty"`

	// Possible values are:
	// - PERIODIC
	// - ONE_TIME
	// - ON_EVENT_DETECTION
	NotifMethod *NotificationMethod `json:"notifMethod,omitempty"`

	// Criteria for partitioning the UEs before applying the sampling ratio.
	PartitionCriteria *[]externalRef0.PartitioningCriteria `json:"partitionCriteria,omitempty"`

	// indicating a time in seconds.
	RepPeriod *externalRef0.DurationSec `json:"repPeriod,omitempty"`

	// Unsigned integer indicating Sampling Ratio (see clauses 4.15.1 of 3GPP TS 23.502), expressed in percent.
	SampRatio *externalRef0.SamplingRatio `json:"sampRatio,omitempty"`
}

// Indicates supported GAD shapes.
type SupportedGADShapes string

// Indicates TSC Traffic pattern.
type TscaiInputContainer struct {
	// string with format 'date-time' as defined in OpenAPI.
	BurstArrivalTime *externalRef0.DateTime `json:"burstArrivalTime,omitempty"`

	// Unsigned Integer, i.e. only value 0 and integers above 0 are permissible.
	Periodicity *externalRef0.Uinteger `json:"periodicity,omitempty"`

	// Unsigned Integer, i.e. only value 0 and integers above 0 are permissible.
	SurTimeInNumMsg *externalRef0.Uinteger `json:"surTimeInNumMsg,omitempty"`

	// Unsigned Integer, i.e. only value 0 and integers above 0 are permissible.
	SurTimeInTime *externalRef0.Uinteger `json:"surTimeInTime,omitempty"`
}

// Indicates value of uncertainty.
type Uncertainty float32

// Ellipse with uncertainty.
type UncertaintyEllipse struct {
	// Indicates value of orientation angle.
	OrientationMajor Orientation `json:"orientationMajor"`

	// Indicates value of uncertainty.
	SemiMajor Uncertainty `json:"semiMajor"`

	// Indicates value of uncertainty.
	SemiMinor Uncertainty `json:"semiMinor"`
}

// Ellipsoid with uncertainty
type UncertaintyEllipsoid struct {
	// Indicates value of orientation angle.
	OrientationMajor Orientation `json:"orientationMajor"`

	// Indicates value of uncertainty.
	SemiMajor Uncertainty `json:"semiMajor"`

	// Indicates value of uncertainty.
	SemiMinor Uncertainty `json:"semiMinor"`

	// Indicates value of uncertainty.
	Vertical Uncertainty `json:"vertical"`
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xbbW/jNvL/KoT+/xd3gDe7m+z2Ie8UW0mFOrJPdtorukVASyObXYpUSSpZ3yLf/UDq",
	"wXqgbMdJ0Tvg3ixiamY4nBnNzI+j/epEPM04A6akc/nVkdEGUmz+dONYXP8RM/13DDISJFOEM+fS8ecI",
	"x7EAKRFm8Vsu0PU/JsGZM3IywTMQioCRkNi5WUwirEAz14xqm4Fz6UglCFs7TyOHZHp/zf3/AhLn0lku",
	"zr//+O37+zFPU84mWOGzLU7p/73dHeBtqf1bv2B+eqoF89XvECkt2E1CkDlVPku4RbkYmCIJAYnUBpAw",
	"pIgnCGcZ1WoTzhDFWxBog1lMCVv3z42ThcIqlw3trWpWqpTUTyMHsPSzEDKKI9AKyr6GY84UJkwiz10g",
	"f45EQZ0CU4iwhIvUKKm1IgpSeaIJvYYmWrYx19PISQnzC7Hva+NiIfBWP1QCJwmJQp4rOHFfw7vkU17Y",
	"WkvNs6s8SXwWW9yVoEyA1GfHLEYSFFIcfXKUyOGTg4g2SRVtaoMVWuVJAjrGtE/zjBL2GZVaa07tc4XF",
	"GhSaBK6PiEQMIIb47BPbRemKcwqYmfgS8EdOBMTO5a87v/+2J+52odE+ypxLSVYU0AOmuX45BFx+Ym/Q",
	"4m489haLS7TcgCUKiUQCcLxFXJQRS0vT6UfawBSU0f8NWnq381nohr/cj2fBjbdY+rOgL7chIcGEShTn",
	"YGwDacYFFlsUcbYGaaJMiw296Wx8H8zu3el09rM3OULkCiKcy0EibXauEKaUP5a6z5Y/eOHxynK1AaEt",
	"I42SzsgBlqfaSaU9nZFjM4czcrrHcUaO2bzh1V2acqkiKo9hX5ozDjU5pCTW72bxojqXTszzFQVn5KT4",
	"C0m1jhfn337zrXnTit9vyoVyc5anKxBmc7amR+6sKc9am3zzrrHFu1o6YQrWhfgxeSCRWyT6vWkcGcqq",
	"JvTzofte/9u33bl9+cK+/MG+/NG+/I19eTIZzyae9dnVdGJdv56G1vUfgtnA+sK6Pr390b4+G1vXA/fW",
	"uj4fDywH9vXpAP3savbPgSeTgfUBhcIB+tBOP0AeTq7CgQcLbzz05O5qiGs2oO7Cc5f2B0u74+4C384Q",
	"8ZwpsbU+S0FteGx9lAn+QGKIr+ycucRrCHNavDudx7aORpfVnJUZ8RoTmgtLVpiYXyvzvkZNDpM4cwEo",
	"BgWRghittsi9ve69xgzLEChgCWNeZLye7gKzDskJLUCwdrOxLg9Dx2UJiYFFx6W+qCZv5b/37w7nP84U",
	"MPUTCGmkdzcLoew9il4xKsjRQ0Gv95Y8rdcbXW5jD49SkklOYldEpnWkdJY4l7/ubxxv3MligzNwnkZf",
	"O06KWtbZJ6RhR91vs4jmMcR1TdnbuBoiw8VAhDgmh5tdv0H6NHJ4kkhQz9st44SpQ9Q3wNcCZxsSYTrm",
	"XMSE6YAwbxaLQOjmWW2P0/lux9Br9gpl2iawbdE+atfQo6bD+m3jb6NOzNXxglwRnZkIUptryh8nTbI9",
	"qAYz5OneiIFCCeWP/Wodg1S3OHoB/Cq5P3yn9WuI84oW/qUSQW2WxkyWBJRoOxxya9deho+Io9iIgKhi",
	"kjwXEbyiraSIXtdUDxSzJV4bv9ZosF+r8JcS053vBXidN6Dygw3tHAzJCSSEmWKU4eizDkZCFYiiWdW4",
	"tgrOfj/WcsMxOErjh8ns52DqBz8WECLiQoDMOIs1FCy3NrgCJEo0lGpjwjvPgJC7+QkiEsHTppArf+KH",
	"3lijDXf6TFkrrjZaJw12u3LvgsXcG/vXfoXAnn9I9LeYPzINiv8+QqtcoQ3WSAzJDCKiKePK7iiGiGIB",
	"8ZnZSoJ4IBGgGCtsPFc2E5pSbjClZt+t2aZURCvQAeBYIpI0aR6xRCtSb4ppsdt8fF1K1ShR40jNU1T8",
	"hhUQYaUgiSIBuGxtNC0D9cjFZ00R/PyGMKKIeZwJHkGcC5DdnTijW1Tm7sPbEYbuPKvc6oQSp5UMA+Ej",
	"IA/QcOri9rqNW6sAdkZOEYbOyGmFkn6w08aKVuu+wXKrpDMLWmFtzG0Gxj037kSfPgOD6WKiGVJdTrnJ",
	"dinOMi348qvjTaf+fDHzJ/duOB7Kn61ex+Aed3p/Prmfz/xgeX8XjL1w6frB8pf7Qpw3JGjKI0zP47mu",
	"wI0SXciHWvTFsOiZP9kr/GJAOCexo4GQHyyH+OdlX1Bs7U6X/vJu4u2lri8RulxNzY+S0GxYKmHN04/9",
	"cDzdr0xDxJiIiIJV0AEPDbtmPpv+cjMLhhnpdl1U17Ir2QY4NVFcNrydbkVW8byvci/yLONCQVy9ALJX",
	"zAo5tlK2ayhdAdg06Wx7RJNeBILu0A9S9W3+XLbKwIf5KvseIb+Oy2dRt5rmA4ytlNDvdnem12UcV3Wo",
	"yOMxSRIQGnEZ3521fdVu/nv5rkmIoh1lvx2m2ECOPfd13zeR5Jvv31lu6mjRqewR8v67lhTzsyOmE7Fa",
	"5sioZ4tav43MDsJkXXMMlEHCMLXuKAlTF+e9K8qPhwC0nz18KO8PQ8zWlrJjlvX2/vzhQ3WBCLLnBDi5",
	"Ha50MO21wkK9WI7tTuJARforgT3Vqs0EWRN2iHHaID0WbodAsSIPMMZCgSSYtSY3VlMcibjrlNaL+52W",
	"oxqG57Zi8zxsbY6PzifIyESPRG1QQyyCOsc6B5uE/3m8bYxn+VzznOj1okE7xe8XB/xulCo9vzPu8Eyk",
	"kMoNpcYDGAkw9SoCJLdSQdrLcrs65A/cHL/oAsyWuIICCOnOxj4Qb14bV6jJ1OLGrFkf73FDoo2pIsF1",
	"DQcjzmSemkHcHznI8qK0qGc66995sgA5nWwfrcm+yTdGlEgzlffe3C1DF0VAKSLmkkvLePHsO1qTg7Pu",
	"dYhZwGPw4+NUDW5Q6AaI8fjlCt5QvsK0VuCgruxogwbhaxszOMaYCh+pnxI4+kzYuozBV9NyiQ8paX17",
	"uCJJOUa5rQc+x831517ozyb+2Ay3A+9+6d96xd/33k9esLyfeMsC2reuASo2Z+RUXObPLpMV/88EAabw",
	"wCVxvynkO3rLCLndslo7wHmVsF5cDF+c+vp398+6bjcnOavP1Jz7v/hsuCFs7yBkh8f+DHuMdoo8yzSN",
	"srn7wqFrqCYq/KtsdmpD9YpzJ/dItdsg+s9ppHteH+iibeqfPreyRIu5zrZ2XLs4mhKp+jlrWpYFI9Ra",
	"BJ7rq90s5P3HZj246Betgaubvz7btVz2GjPOprhTnd30b2QsdWYz4n8CZH5F67/+2/oKQPegf0qkWzqo",
	"uDF8tbCu3uSDF4qG0GoG8+SIg5a6m3MMw1bLhx0FKappUU3cxSpfTmw4rynHpof818sEdMzzxXoZGELG",
	"hSJs7e9A28HvWcwYiCdIVMzFF7RmeJWvakZUbm+5Ol2LLIRsSdJTvwSa5MLouoDIfG2SpiFkDWRcf4hr",
	"8nZxymB16ij+rtG4auL8VEETrMCcWkMvDRGuKV6fCp8aEMOIqWTu8Ma+F8mCUHSCw0LDJs7GgigQBFuw",
	"V/nEDAJr+iIKQAN3tIKEi+Jr3G21LnGaUf3D+O2loGze2LbW9BCUFJDNQRAev07M6ROFeuFEcYvSIoUM",
	"K4q0TKf2gDNZUXfGszVANMPJPcO/feO83XyuN8DcO5scdSbAR013j5zT2oDsUkaY+CzLVXlHAGKfzZaL",
	"MVqWHxlkWCkQ5v9HsJxSvNItmxI5dLPXKhdSuUKQB0xfksMaySAzgUki0mrLTs1RMhdasM+CPL2V69eU",
	"+ILz7uTZYr0DAw/eQDS6ktZEKjHVz3r9sJu62dtKWy8EvR6oX80alyG3+Hd+8HOx5mWLti2k5Ci+DvQz",
	"fIQ9k6873a43bwoc9c/0236fte70h5rKrin/uy05ch605hGmf4YDatlH+eLJfHJbXNMronTmKr/cKUQV",
	"3yk778/enb0zH9lmwHBGnEvnwizpyq820rnUme/p3wEAAP//LXRvvPw3AAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
